#include "pgm.h"
#include <math.h>

/* reads in two pgm files and displays the difference in pgm format */
/* with a comment denoting the number of pixels differing */
main(int argc, char* argv[])
{
  unsigned char *image1, *image2, *diffed;
  int width1, height1, size1, max1;
  int width2, height2, size2, max2;
  char base[20], fname[35], comment[80];

  max1=read_pgm(argv[1], &image1, &width1, &height1);
  size1=width1*height1;
  max2=read_pgm(argv[2], &image2, &width2, &height2);
  size2=width2*height2;

  if ((width1==width2)&&(height1==height2)&&(max1==max2))
  {
    diffed = (unsigned char *) calloc(size1, 1);
    diff(image1, image2, diffed, size1, comment);
    write_pgm("diffed.pgm", diffed, width1, height1, max1, comment);
  }
  else 
  {
    printf("Cannot diff images\n");
    printf("image: \t%s\t%s\n", argv[1], argv[2]);
    printf("width: \t%d\t%d\n", width1, width2);
    printf("height:\t%d\t%d\n", height1, height2);
    printf("max:   \t%d\t%d\n", max1, max2);
  }

  free(image1);
  free(image2);

}

void diff(unsigned char *im1, unsigned char *im2, unsigned char *result,
	int size, char *comment)
{
  int i, count=0;

  for (i=0; i<size; i++)
  {
    result[i]=abs(im1[i]-im2[i]);
    if (result[i]) count++;
  }

  sprintf(comment, "Number of differing pixels = %d", count);
}
